function [mFR, mbic]=FRIIs2(x,y,bicopt)
    [ss,p] = size(x);
    %nStep=ceil(min((p^2+3*p)/2,ss/4));  
    nStep=ceil(min(p*3,ss/4));
    L2=zeros(nStep,1);												%initial step RSS
    out0 = 1:p;                                                     %index set
    mFR  = [];                                                      %solution path
    inmainid = [];                                                  %selection main effect
    X=x;Y=y;														%backup x and y
    candy = out0;                                                   %candidate set
    Xin = [];                                                       %columns of selected variables
    
    for k=1:nStep
        L2(k)=norm(y);													%current RSS
	    XL2=sum(x.^2,1)';												%Xj's L2 norm squared
        XL2=sqrt(XL2);                                                  % corrected 03/17/2016
        XL2(find(XL2==0))=1;                                            %kind of ignore zero columns
	    r=abs(x'*y)./XL2;												%absolute partial corr
	    id=find(max(r)==r);id=id(1);									%find best predictor
	    ak=candy(id);														%find the best predictor
        
	    mFR=[mFR,ak];													%update solution path
        if ak<p+1;              
            inmainid = [inmainid ak];                                   %update main effect
        end
        
        xj=x(:,id);        
	    if norm(xj)>0; 
		     xj=xj/norm(xj); 
	    end;	                                                      %make norm(xj)=1
        
        Xin = [Xin xj];                                               %update design matrix of selected variables                                     
	    x(:,id)=[];
	    candy(id)=[];														%eliminate xj 
	    y=y-xj*(xj'*y);
	    x=x-xj*(xj'*x);													%do profiling
        
        if ak<p+1;
           newcandy = setdiff(genIds(inmainid,p),union(candy,mFR));
           candy    = [candy newcandy];                                  %update candidate set
           Xnew     = [];
           for kk=1:length(newcandy)
               [aa bb]=findpair(newcandy(kk), p);
               Xab = X(:,aa).*X(:,bb);
               Xab = Xab-mean(Xab);
               Xnew = [Xnew Xab];
           end
           Xnew = Xnew-Xin*(Xin\Xnew);
           x    = [x Xnew];                                              %update x
        end
    end
     
	if bicopt== 0
		BIC=2*log(L2)+[1:nStep]'*log(ss)/ss;                        %NOTE: L2^2=RSS
	end
	if bicopt==1
	BIC=2*log(L2)+[1:nStep]'*(log(ss)+2*log(p+length(inmainid)^2/2))/ss;
    end
    
    mbic=find(min(BIC)==BIC)-1;                                        %best stopping position
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
              
