clear all;																%clear working space
nsimu=100;                                                                %number of iterations
MM = 40;
totalpath = [];
fid = fopen('Output.txt','wt');                                     %open output files   

record=zeros(nsimu,11,3);                                          %record simu results

% two parameters: "model" and "option", control different simulation settings.
%"model" controls the correlation structure
%"option" controls the signal-to-noise ratio


for model=1:1
    for option=1:3
        [model,option]   
        fprintf(fid,'Option--%1.0f:\n', option);                           %output option
        for k=1:nsimu
    		rand('state',k);randn('state',k);                              %fix the RANDN seed
            k %track the simulation number
	        [R2,x,y,x1,y1,beta0,betapair0,Beta0,pairindex,ss0,ncov,meanx,varx,meany]=simulator4(model,option);        
            dim = length(beta0);  %length of main effect length
            Dim = dim*(dim+3)/2;  %the total length of coefficients
            n = length(y); 
            
            %centering and standardizing x and y
            for j=1:ncov
                x0(:,j) = (x(:,j)-meanx(j))./sqrt(varx(j));
            end
            y0 = y - meany;
    
            %oracle
            tt = 1:length(Beta0);
            nonzid = tt(Beta0~=0);
            XX = genSelXXNN(x,nonzid);
            bb = [ones(n,1) XX]\y;
         
            
            %two-step FRI under strong heredity
            bicopt = 1;
            t0 = cputime;
            [mFRIsfull, mFRIs]=FRIs(x0,y0,bicopt);                      
            if (isempty(mFRIs))
                beta1=meany;
            else
                XFRIs = genSelXXNN(x,mFRIs); %[XFRIs, meanXX, varXX] = genSelXX(x0,mFRIs);
                %beta1=OLS(XFRIs,y0,1:length(mFRIs)); %OLS refit                
                %beta1 = beta1./sqrt(varXX')';
                beta1 = [ones(n,1) XFRIs]\y;
            end
           
            
            %iterative FRII model+strong heredity
            [mFRIIsfull, mbicIIs]=FRIIs2(x0,y0,bicopt);
            if mbicIIs>0
               mFRIIs = mFRIIsfull(1:mbicIIs);
            else
               mFRIIs =[];
            end
            if (isempty(mFRIIs))
                beta2=meany;
            else
            XFRIIs = genSelXXNN(x,mFRIIs); %[XFRIIs,meanXX,varXX] = genSelXX(x0,mFRIIs);
            %beta2 = OLS(XFRIIs,y0,1:length(mFRIIs)); %OLS refit                
            %beta2 = beta2./sqrt(varXX')';
            beta2 = [ones(n,1) XFRIIs]\y;
            end
          
           B={beta1, beta2,bb};  
           AllFR ={mFRIs,mFRIIs,nonzid};
            for kk=1:length(B)                                     %evaluate very est.
                record(k,:,kk)=evaluate(B{kk},AllFR{kk},Beta0(nonzid),nonzid,x1,y1,ncov);           %evaluate estimate
            end
            
             
        end
 

        %------------------- Output SimuResult.txt------------------------%
        for kk=1:(length(B(1,:)))                                         %output method name
            switch kk                                                   
				
				case 1; fprintf(fid,' FRIs &NONE  ');
               
                case 2; fprintf(fid,' FRIIs&NONE  ');
               
                case 3; fprintf(fid,'   ORACL&   ');
                
		    end
            out=mean(record(:,:,kk),1);                                         %average evaluate crit.
            for jj=1:length(out);
                fprintf(fid,'& %9.2f ', out(jj));
            end                                                                 %output performance measure
            fprintf(fid,'& %9.2f',std(record(:,length(out),kk))/sqrt(nsimu));   %output Rsq's SD
            fprintf(fid,'\\\\ \n',[]);                                          %jumps into another line
            %if(kk==5); fprintf(fid,'\n',[]); end    
            fprintf(fid,'\n',[]);                                               %starts a new line
        end
        fprintf(fid,'\n',[]);
        fprintf(fid,' Computation Time--%1.0f:\n', model); 

    end
    fprintf(fid,'\n',[]);                                               %jump into another line 
end
fclose(fid);                                                            %close output files
%saveas(hh,'path78.pdf');
diary off; 



